"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);
var import_kit = require("@nuxt/kit");
var import_common = require("@vue-macros/common");
var import_unplugin_vue_macros = require("unplugin-vue-macros");
var import_vite = __toESM(require("unplugin-vue-macros/vite"), 1);
var module2 = (0, import_kit.defineNuxtModule)({
  meta: {
    name: "vue-macros",
    configKey: "macros"
  },
  defaults: {},
  setup(options) {
    const nuxt = (0, import_kit.useNuxt)();
    const resolvedOptions = (0, import_unplugin_vue_macros.resolveOptions)(options);
    nuxt.options.typescript.tsConfig ||= {};
    nuxt.options.typescript.tsConfig.vueCompilerOptions ||= {};
    const vueCompilerOptions = nuxt.options.typescript.tsConfig.vueCompilerOptions;
    vueCompilerOptions.plugins ||= [];
    vueCompilerOptions.plugins.push("unplugin-vue-macros/volar");
    nuxt.hook("vite:configResolved", (config, { isClient }) => {
      function findPluginAndRemove(name) {
        const idx2 = config.plugins.findIndex(
          (plugin2) => plugin2 && "name" in plugin2 && plugin2.name === name
        );
        if (idx2 === -1) return [null, idx2];
        const plugin = config.plugins[idx2];
        config.plugins.splice(idx2, 1);
        return [plugin, idx2];
      }
      config.plugins ||= [];
      const [vue, idx] = findPluginAndRemove("vite:vue");
      const [vueJsx] = findPluginAndRemove("vite:vue-jsx");
      const vueMacrosPlugins = (0, import_vite.default)({
        ...resolvedOptions,
        plugins: { vue, vueJsx },
        nuxtContext: { isClient }
        // TODO: no config file
      });
      if (idx !== -1) {
        config.plugins.splice(idx, 0, ...vueMacrosPlugins);
      } else {
        config.plugins.push(...vueMacrosPlugins);
      }
    });
    nuxt.hook("prepare:types", (opts) => {
      opts.references.push({ types: "unplugin-vue-macros/macros-global" });
    });
    nuxt.hook("devtools:customTabs", (tabs) => {
      tabs.push({
        name: "vue-macros",
        title: "Vue Macros",
        icon: `https://raw.githubusercontent.com/${"vue-macros/vue-macros"}/main/docs/public/favicon.svg`,
        view: {
          type: "iframe",
          src: "/__vue-macros"
        }
      });
    });
    const viteVue = nuxt.options.vite.vue ||= {};
    if (resolvedOptions.setupSFC) {
      viteVue.include ||= [/\.vue$/];
      if (!Array.isArray(viteVue.include)) viteVue.include = [viteVue.include];
      viteVue.include.push(import_common.REGEX_SETUP_SFC);
      nuxt.hook("components:extend", (components) => {
        for (const component of components) {
          component.pascalName = component.pascalName.replace(/Setup$/, "");
          component.kebabName = component.kebabName.replace(/-setup$/, "");
        }
      });
      nuxt.hook("pages:extend", (pages) => {
        for (const page of pages) {
          if (!page.file || !import_common.REGEX_SETUP_SFC.test(page.file)) continue;
          if (page.name) page.name = page.name.replace(/\.setup$/, "");
          if (page.path)
            page.path = page.path.replace(/\/index\.setup$/, "/").replace(/\.setup$/, "");
        }
      });
    }
    nuxt.hook("app:resolve", (app) => {
      app.layouts = Object.fromEntries(
        Object.entries(app.layouts).map(([key, value]) => {
          if (key.endsWith("-setup")) {
            key = key.replace(/-setup$/, "");
            value.name = value.name.replace(/-setup$/, "");
          }
          return [key, value];
        })
      );
    });
  }
});
var src_default = module2;
